unit AddFile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, filtr, Buttons, ExtCtrls, Gauges, ComCtrls, dbtables;

type
  TfAddFile = class(TForm)
    llLine: TLabel;
    llMail: TLabel;
    lLine: TLabel;
    lMail: TLabel;
    Bevel1: TBevel;
    anPos: TAnimate;
    pbPos: TProgressBar;
    lFile: TLabel;
    Bevel2: TBevel;
    edComment: TEdit;
    lComment: TLabel;
    btStop: TButton;
    procedure FormActivate(Sender: TObject);
    procedure btStopClick(Sender: TObject);
  private
    { Private declarations }
    RecordCountBefore: integer;
    LastIDBefore: integer;
    LastSubjectBefore: string;
    LineNum: longint;
  public
    { Public declarations }
//    function AddFileToDB (FileName: string): boolean;
    function AddFileToDB (FileName, AttachDir: string): boolean;
    procedure SetBtOK;
  end;

var
  fAddFile: TfAddFile;
  AttachDirectory, Path: string;
  StopReading : boolean;
  Kind: integer;


implementation

uses Main, Utils;

{$R *.DFM}

procedure TfAddFile.SetBtOK;
begin
  btStop.Tag := 0;  {Kind := bkOK;}
  btStop.Caption := '&OK';
end;

{----------------------------------------------------------------AddFileToDB---}
function TfAddFile.AddFileToDB (FileName, AttachDir: string): boolean;
var
//  i: integer;
  F: System.Text;
  S, From, Subject, DT, Boundary, Cap: string;
  MailNum: longint;
  EndOfMail: Boolean;
  MyList: TStringList;
  FileLen, ActFilePos: longint;
  Refresh: integer;
  LoopCondition, BodyLoopCondition: Boolean;

  // Html promenne
  HtmlDay, HtmlMonth, HtmlFile: integer;
  HtmlFileName: string;
  PomRecCount: integer;

procedure OnClose; // Co se deje pri ukoncovani (kdyz vyskoci z cyklu)
begin
  case Kind of
    afkMail:  System.Close (F);
  end; //case

  anPos.Active := false;
  MyList.Free;
end;

begin { AddFileToDB }
  AddFileToDB := false;
  LoopCondition := false;
  BodyLoopCondition := true;
  FileLen := 0;
  if (AttachDir <> '') and (AttachDir[Length(AttachDir)] <> '\') then
    AttachDir := AttachDir + '\';

  //------------------------
  // Inicializace
  // Pro kazdy druh jina
  //------------------------

  case Kind of
    afkMail: begin
      pbPos.Visible := true;
      anPos.Active := true;
      llLine.Caption := 'dek:';
      llMail.Caption := 'Zprva';
      pbPos.Enabled := true;
      FileLen := MyGetFileSize (FileName);
      { Otevru soubor pro cteni }
      System.assign (F,FileName);
      {$I-} reset (F); {$I+}
      if IOResult <> 0 then begin
        MessageDlg ('Nepodailo se otevt soubor!'+#13+'('+FileName+')',
                     mtError, [mbOK], 0);
        SetBtOK;
        exit;
      end;
      ActFilePos := 0;
      LineNum := 0;
      LoopCondition := not eof (F);
    end; // Mail - inicializace

    afkHtml: begin
      pbPos.Visible := false;
      anPos.Active := true;

      llLine.Caption := 'Datum:';
      llMail.Caption := 'Zprva';

      // Zkontroluju Path (musi to byt adresar a musi existovat)
      if (Path[Length(Path)] <> '\') then Path := Path + '\';
      if (not ExistsDir (Path)) then begin
        MessageDlg ('Zadan adres neexistuje!'+#13+'('+Path+')',
                     mtError, [mbOK], 0);
        SetBtOK;
        OnClose;
        exit;
      end;

      HtmlDay := 1;
      HtmlMonth := 1;
      HtmlFile := 0;

      LoopCondition := true;

    end;
  end; // case

  // Spolecna inicializace
  MailNum := 0;
  Refresh := 0;
  MyList := TStringList.Create;

  //----------------------------
  //  CYKLUS pro jednotlive zpravy
  //----------------------------
  while (LoopCondition) do begin

    inc (MailNum);  // Zvedne se pocet pridanych meiliku
    inc (Refresh);  // Zvedne se refresh

    // Kontrola, zda uzivatel neche zrusit nacitani
    if (StopReading) then begin
      OnClose;
      exit;
    end;

    //---------------------------
    // Nacteni udaju z HLAVICKY
    //---------------------------
    case Kind of
      afkMail: begin
        if (ReadMailHeader (F, From, Subject, DT, Boundary, LineNum, ActFilePos) = 1) then begin
          MessageDlg ('Neoekvan konec souboru ('+ IntToStr (LineNum)+')',
                      mtError, [mbOK], 0);
          SetBtOK;
          OnClose;
          exit;
        end;
      end; // Mail

      afkHtml: begin
        // Otevre si prislusny soubor
        HtmlFileName := NextHtmlFile (Path, HtmlMonth, HtmlDay, HtmlFile);
        Subject := HtmlFileName;
        if (HtmlFileName = '') then begin
          SetBtOK;
          OnClose;
          exit;
        end;
        { Otevru soubor pro cteni }
        System.assign (F, HtmlFileName);
        {$I-} reset (F); {$I+}
        if IOResult <> 0 then begin
          MessageDlg ('Nepodailo se otevt soubor!'+#13+'('+HtmlFileName+')',
                       mtError, [mbOK], 0);
          SetBtOK;
          OnClose;
          exit;
        end;

        if (ReadHtmlHeader (F, From, Subject, Dt) = 1) then begin
          MessageDlg ('Neoekvan konec souboru!', mtError, [mbOK], 0);
          SetBtOK;
          OnClose;
          exit;
        end;
      end; // Html
    end; // case

    // Poupravujeme Subject a Autora

    // Upravime subjekt - vynechame RE
    TrimSubj (Subject);

    Subject := ConvertSubjAutor (Subject);
    From    := StringReplace (From, '"', '', [rfReplaceAll]);
    From    := ConvertSubjAutor (From);

    // Upravime subjekt - vynechame RE
    TrimSubj (Subject);

    // a jeste pro jistotu useknu pocatecni a koncove mezery...
    Subject := Trim (Subject);
    if (Subject = '') then Subject := 'None';
    From := Trim (From);
    if (From = '') then From := 'None';
    Dt := Trim (Dt);
    if (Dt = '') then Dt := 'None';


    //-----------------------
    // Nacteni telicka MAILU
    //-----------------------
    MyList.Clear;

    { pripravime si Query pro kontrolu existence vety }
    fMain.qrPom.Close;
    fMain.qrPom.DatabaseName := fMain.DatabaseName;
    fMain.qrPom.SQL.Text := Format (
       'Select SUBJECT,AUTOR,DATUM from "%s" where'+
       ' (SUBJECT=:Subject and AUTOR=:Autor and DATUM=:Datum)',[fMain.TableName]);
    fMain.qrPom.Prepare;

    { pripravime si Query pro pridani mailu }
    fMain.qrMain.Close;
    fMain.qrMain.DatabaseName := fMain.DatabaseName;
    fMain.qrMain.SQL.Text := Format (
      'Insert into "%s" (SUBJECT, AUTOR, DATUM, MAIL)'+
      '        Values (:Subject, :Autor, :Datum, :Mail)',[fMain.TableName]);
    fMain.qrMain.Prepare;

    repeat

      case Kind of
        afkMail: begin
          if (eof (F)) then begin
            MessageDlg ('Neoekvan konec souboru ('+ IntToStr (LineNum)+')',
                     mtError, [mbOK], 0);
            SetBtOK;
            System.Close (F);
            exit;
          end;

          System.ReadLn (F, S);
        end; // Mail

        afkHtml: begin
          if (eof (F)) then begin
            MessageDlg ('Neoekvan konec souboru', mtError, [mbOK], 0);
            SetBtOK;
            System.Close (F);
            OnClose;
            exit;
          end;

          System.ReadLn (F, S);
        end; // Html

      end; // case

      // Zvyseni pozice
      inc (Refresh);
      inc (LineNum);
      ActFilePos := ActFilePos + length (S) + 2;

      //-----------------------
      // Refresh a zobrazeni
      //-----------------------
      if (Refresh > 50) then begin
        lMail.Caption :=  IntToStr (MailNum);

        case Kind of
          afkMail: begin
            lLine.Caption :=  IntToStr (LineNum);
            pbPos.Position := longint (longint ((longint (100) *
                              longint (ActFilePos div 100))) div
                              longint (FileLen div 100));
          end; // mail
          afkHtml: begin
            Cap := Filtr.cMonths [HtmlMonth]+'\';
            if (HtmlDay < 10) then Cap := Cap + '0';
            Cap := Cap + IntToStr (HtmlDay) + '\' + IntToStr (HtmlFile);
            lLine.Caption := Cap;
          end; // Html

        end; // case

        Application.ProcessMessages;
        Refresh := 0;
      end;

      // koncova podminka

      case Kind of
        afkMail: begin
          EndOfMail := isMailEOM (S);
          if (not EndOfMail) then MyList.Add (S);
          BodyLoopCondition := (EndOfMail) or eof (F);
        end; // mail

        afkHtml: begin
          EndOfMail := IsHtmlBodyEnd (S);
          if (not EndOfMail) then MyList.Add (S);
          BodyLoopCondition := (EndOfMail) or eof (F);
        end; // html
      end; // case
    until (BodyLoopCondition);

    //-------------------
    // Vlozeni zaznamu
    //-------------------
    // Mam Subject, Autor, Datum a vlastni mail Mail
    // Upraveni Mailu
    //---------------------------------
    // pro test na jedinecnost zaznamu
    //---------------------------------
    fMain.qrPom.ParamByName ('Subject').AsString := Subject;
    fMain.qrPom.ParamByName ('Autor').AsString := From;
    fMain.qrPom.ParamByName ('Datum').AsString := Dt;
    try
      fMain.qrPom.Open;
      PomRecCount := fMain.qrPom.RecordCount;
    except
      PomRecCount := 1;
    end;
    fMain.qrPom.Close;

    if PomRecCount<1 then begin
// -------------------------------
//    ShowMessage ('---'+Subject+'---'+From+'---'+Dt+'---');
      PrepareMail (MyList, AttachDir, Boundary);
      try
        Close;
        fMain.qrMain.ParamByName ('Subject').AsString := Subject;
        fMain.qrMain.ParamByName ('Autor').AsString := From;
        fMain.qrMain.ParamByName ('Datum').AsString := Dt;
        fMain.qrMain.ParamByName ('Mail').AsBlob := MyList.Text;
        fMain.qrMain.ExecSQL;
        fMain.qrMain.Close;
      except
        on E:EDBEngineError do begin
          ShowMessage ('Chyba pi vkldn zznamu do databze:'+#13+#10+
                        E.Message);
          SetBtOK;
          System.Close (F);
          exit;
        end; // EDBEngineError
      end; //try
    end;  // PomRecCount<1

    // Obnova podminky cyklu
    case Kind of
      afkMail: LoopCondition := not eof (F);
    end; // case
  end; {While}

  pbPos.Position := 100;
  System.Close (F);
  anPos.Active := false;
  SetBtOK;
end;  { AddFileToDB }

{...............................................................FormActivate...}
procedure TfAddFile.FormActivate(Sender: TObject);
begin
  StopReading := false;
  lFile.Caption := Path;
  RecordCountBefore := fMain.TotalRecords (fMain.DatabaseName, fMain.TableName);
  fMain.LastMailInDB (LastIDBefore, LastSubjectBefore);

  AddFileToDB (Path, AttachDirectory);

end;

procedure TfAddFile.btStopClick(Sender: TObject);
var
  TotalRec: longint;
begin
  if btStop.Tag = 1 then begin
    SetBtOK;
    StopReading := true;
  end else begin
    // Jeste pridam komentare a podobne
    TotalRec := fMain.TotalRecords (fMain.DatabaseName, fMain.TableName);
    fMain.AddDBComment ('-', '');
    fMain.AddDBComment ('', FormatDateTime ('d. mmmm yyyy (hh:nn:ss)', now));
    fMain.AddDBComment ('-','');
    fMain.AddDBComment ('Soubor', Path);
    fMain.AddDBComment ('Prispevku pred', IntToStr (RecordCountBefore));

    fMain.AddDBComment ('Prispevku po', IntToStr (TotalRec));

    fMain.AddDBComment ('Pridano prispevku',
      IntToStr (TotalRec - RecordCountBefore));

    fMain.AddDBComment ('Zpracovanych radku', IntToStr (LineNum));

    fMain.AddDBComment ('Posledni prispevek pred',
      Format ('ID: %d (%s)', [LastIDBefore, LastSubjectBefore]));

    fMain.LastMailInDB (LastIDBefore, LastSubjectBefore);
    fMain.AddDBComment ('Posledni prispevek po',
      Format ('ID: %d (%s)', [LastIDBefore, LastSubjectBefore]));

    fMain.AddDBComment ('Komentar', edComment.Text);
    fMain.AddDBComment ('','');
    Close;
  end;
end;

end.
