unit Book;

interface

uses
{  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, IniFiles, Buttons;
}
  procedure AddBookItem (S: string);
  function FindItem (MI: TComponent; S: string): TMenuItem;
  procedure ClearBookmarks;

var
  fMain: TfMain;

implementation

uses EditMenuBook;

{$R *.DFM}

procedure TfMain.Button1Click(Sender: TObject);
begin
  //
  AddBookItem ('Ahoj|Toto|je|test|12');
  AddBookItem ('Ahoj|Tamto|jest|32');
  AddBookItem ('Aha|123');


end;


//------------------------------------------------------------------------------
//                                                                     FindItem
//------------------------------------------------------------------------------
function TfMain.FindItem (MI: TComponent; S: string): TMenuItem;
var
  i: integer;
begin { FindItem }
  if (MI is TMenuItem) then begin
    for i := 0 to TMenuItem (MI).Count-1 do
      if (UpperCase (TMenuItem (MI).Items[i].Caption) = UpperCase (S)) then begin
        Result := TMenuItem (MI).Items[i];
        Exit;
      end;
  end else begin
    for i := 0 to TPopUpMenu (MI).Items.Count-1 do
      if (UpperCase (TPopUpMenu (MI).Items[i].Caption) = UpperCase (S)) then begin
        Result := TPopUpMenu (MI).Items[i];
        Exit;
      end;
  end;

  Result := nil;
end;  { FindItem }


//------------------------------------------------------------------------------
//                                                                  AddBookItem
//------------------------------------------------------------------------------
procedure TfMain.AddBookItem (S: string);
const
  cMenuSep = '|';
var
  MM, M: TMenuItem;
  l, i, TT: integer;
  NewMenuItem: TMenuItem;
  S1: string;
begin { AddBookItem }

  i := Pos (cMenuSep, S);
  l := 0;
  M := nil;
  NewMenuItem := nil;

//  M := pm
  while (i <> 0) do begin
    S1 := Copy (S, 1, i-1);
    S := Copy (S, i+1, Length (S) - i);

    if (l = 0) then
      MM := FindItem (pmBookmark, S1)
    else
      MM := FindItem (M, S1);

    if (MM = nil) then begin
      // Vetev neexistuje - vytvorime novou
      NewMenuItem := TMenuItem.Create (pmBookmark);
      NewMenuItem.Caption := S1;
      if (l = 0) then
        pmBookmark.Items.Add (NewMenuItem)
      else
        M.Add (NewMenuItem);

      M := NewMenuItem;
    end else begin
      // Vetev existuje - prejdeme do ni
      M := MM;
    end;

    inc (l);

    i := Pos (cMenuSep, S);
  end;
  try
    TT := StrToInt (S);
  except
    On EConvertError do TT := 0;
  end;

  if (NewMenuItem <> nil) then NewMenuItem.Tag := TT

end;  { AddBookItem }

procedure SaveBokmarksToFile (IniFile: TIniFile; Sec, Name: string; PM: TPopUpMenu);
var
  Total: integer;
  j: integer;
  S: string;

procedure SaveMenuItem (Item: TMenuItem; S: string);
var
  i: integer;
begin
  if (S <> '') then S := S + '|';
  S := S + Item.Caption;

  // Zjisti, zda je koncova polozka
  if (Item.Count = 0) then begin
    S := S + '|' + IntToStr (Item.Tag);
    IniFile.WriteString (Sec, Name+'_'+IntToStr (Total), S);
    inc (Total);
    Exit;
  end;

  // Neni to koncova - for cyklus
  for i := 0 to Item.Count -1 do
    SaveMenuItem (Item.Items[i], S);
end;

begin
  // Ulozeni popup menu do souboru
  Total := 0;
  for j := 0 to PM.Items.Count-1 do begin
    SaveMenuItem (PM.Items[j], S);
  end;
  IniFile.WriteInteger (Sec, Name+'_Count', Total);
end;


procedure TfMain.Button2Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create (ChangeFileExt (Application.ExeName, '.ini'));

  SaveBokmarksToFile (IniFile, 'Menu', 'Delphi', pmBookmark);

  IniFile.Free;
end;

procedure LoadBokmarksFromFile (IniFile: TIniFile; Sec, Name: string; PM: TPopUpMenu);
var
  Total: integer;
  j: integer;
  S: string;
begin
  Total := IniFile.ReadInteger (Sec, Name+'_Count', 0);
  for j := 0 to Total-1 do begin
    S := IniFile.ReadString (Sec, Name+'_'+IntToStr (j), '');
    if (S = '') then Continue;
    fMain.AddBookItem (S);
  end;
end;

procedure TfMain.Button3Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create (ChangeFileExt (Application.ExeName, '.ini'));

  LoadBokmarksFromFile (IniFile, 'Menu', 'Delphi', pmBookmark);

  IniFile.Free;

end;

procedure TfMain.Button4Click(Sender: TObject);
begin
  fEditMenuBook.ShowModal;
end;


procedure TfMain.ClearBookmarks;
var
  j: integer;
begin
  for j := 0 to fMain.pmBookmark.Items.Count-1 do
    fMain.pmBookmark.Items.Delete (0);//pmBookmark.Clear;
end;

end.
