unit edBookmark;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
  TfEdBookmark = class(TForm)
    lvBookmark: TListView;
    btCancel: TButton;
    btOK: TButton;
    btDelete: TButton;
    btDown: TButton;
    btUp: TButton;
    procedure FormActivate(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure btDownClick(Sender: TObject);
    procedure btUpClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetEnabl;
  public
    { Public declarations }
  end;

var
  fEdBookmark: TfEdBookmark;

implementation

uses Main, Menus;

{$R *.DFM}

procedure TfEdBookmark.FormActivate(Sender: TObject);
var
  Count, i: integer;
  NewItem: TListItem;
begin
  // Nacteme zalozky
  lvBookmark.Items.Clear;
  Count := fMain.miBookmark.Count - 3;

  for i := 0 to Count-1 do begin
    NewItem := lvBookmark.Items.Add;
    NewItem.Caption := IntToStr (fMain.miBookmark[i].Tag);
    NewItem.Subitems.Add (fMain.miBookmark[i].Caption);
  end;

  if (lvBookmark.Items.Count > 0) then lvBookmark.Selected := lvBookmark.Items[0];
  SetEnabl;
end;

procedure TfEdBookmark.btDeleteClick(Sender: TObject);
var
  i: integer;
begin
  if (lvBookmark.Selected = nil) then exit;
  i := lvBookmark.Selected.Index;
  lvBookmark.Selected.Delete;
  if (lvBookmark.Items.Count > 0) then begin
    if (i < lvBookmark.Items.Count) then
      lvBookmark.Selected := lvBookmark.Items[i]
    else
      lvBookmark.Selected := lvBookmark.Items[i-1];
  end;
  SetEnabl;
end;

procedure TfEdBookmark.SetEnabl;
begin
  btDelete.Enabled := (lvBookmark.Selected <> nil);
  btUp.Enabled := (lvBookmark.Selected <> nil);
  btDown.Enabled := (lvBookmark.Selected <> nil);
end;

procedure TfEdBookmark.btOKClick(Sender: TObject);
var
  Count, i: integer;
  NewMenuItem: TMenuItem;
begin
  // Provedeni zmen
  // 1) Smazani polozek v menu
  Count := fMain.miBookmark.Count - 3;

  for i := 0 to Count-1 do
    fMain.miBookmark.Delete(0);

  // 2) Vlozime tam nove polozky z toho ListViewu
  for i := lvBookmark.Items.Count-1 downto 0 do begin
    NewMenuItem := TMenuItem.Create (fMain.miBookmark);
    NewMenuItem.Tag := StrToInt (lvBookmark.Items[i].Caption);
    NewMenuItem.Caption := lvBookmark.Items[i].Subitems[0];
    NewMenuItem.OnClick := fMain.miBookClick;
    NewMenuItem.Hint := Format ('Skok na zloku "%s" (%d)',
      [NewMenuItem.Caption, NewMenuItem.Tag]);

    fMain.miBookmark.Insert (0, NewMenuItem);
  end;
end;

procedure TfEdBookmark.btDownClick(Sender: TObject);
var
  NewItem: TListItem;
begin
  // Posunuti dolu
  if (lvBookmark.Selected = nil) then exit;
  if (lvBookmark.Selected.Index = lvBookmark.Items.Count-1) then exit;

  NewItem := lvBookmark.Items.Insert (lvBookmark.Selected.Index+2);
  NewItem.Assign (lvBookmark.Selected);
  lvBookmark.Selected.Delete;
  lvBookmark.Selected := NewItem;
  lvBookmark.CheckBoxes := false;
end;


procedure TfEdBookmark.btUpClick(Sender: TObject);
var
  NewItem: TListItem;
begin
  // Posunuti nahoru
  if (lvBookmark.Selected = nil) then exit;
  if (lvBookmark.Selected.Index = 0) then exit;

  NewItem := lvBookmark.Items.Insert (lvBookmark.Selected.Index-1);
  NewItem.Assign (lvBookmark.Selected);
  lvBookmark.Selected.Delete;
  lvBookmark.Selected := NewItem;
  lvBookmark.CheckBoxes := false;
end;

end.
